<?xml version="1.0" encoding="utf-8"?>
<!-- file: sol_trans.xslt -->
<xsl:stylesheet version="1.0"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:msxsl="urn:schemas-microsoft-com:xslt"
	xmlns:xsd="http://www.w3.org/2001/XMLSchema" 
	xmlns:msdata="urn:schemas-microsoft-com:xml-msdata"
	xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
  xmlns="http://www.w3.org/TR/html4"
	exclude-result-prefixes="xsl msxsl xsd msdata xsi">

  <xsl:output method="html" 
		encoding="windows-1252" 
		version="4.0"
		indent="no" 
		doctype-public="-//W3C//DTD HTML 4.0 Transitional//EN" />

  <xsl:strip-space elements="*" />
  
  <xsl:param name="prmRootParent">
    <xsl:text>0_</xsl:text> 
  </xsl:param>
  <xsl:param name="prmTitle">
    <xsl:text>Example of tree-like conversion solution.dbf file into HTML</xsl:text>
  </xsl:param>
  
  <xsl:variable name="varInpDoc">
    <xsl:copy-of select="/./*" />
  </xsl:variable>

  <xsl:template match="/">
    <html>
      <head>
        <meta name="vs_targetSchema" content="http://schemas.microsoft.com/intellisense/ie5" />
        <meta http-equiv="Content-Type" content="text/html; charset=windows-1252" />
        <meta http-equiv="Content-Language" content="en" />
        <title>
          <xsl:value-of select="$prmTitle" />
        </title>
        <style>
          <xsl:comment>
            body {
            font-family: Verdana, Arial, Helvetica, sans-serif;
            font-size: 70%; }
            .css_item {
            padding-left: 15; }
            .css_path {
            font-style: italic;
            font-weight: bold; }
          </xsl:comment>
        </style>
      </head>
      <body>
        <xsl:apply-templates select="msxsl:node-set($varInpDoc)/./*/row[@parent=$prmRootParent]">
          <xsl:sort select="@text"/>
          <xsl:sort select="@path"/>
        </xsl:apply-templates>
      </body>
    </html>
  </xsl:template>

  <xsl:template match="row">
    <xsl:variable name="varCurKey">
      <xsl:value-of select="@key" />
    </xsl:variable>
    <xsl:variable name="varChildNodes">
      <xsl:copy-of select="msxsl:node-set($varInpDoc)/./*/row[@parent=$varCurKey]" />
    </xsl:variable>
    <xsl:variable name="varChildCount">
      <xsl:value-of select="count(msxsl:node-set($varChildNodes)/*)" />
    </xsl:variable>
    <div class="css_item">
      <span>
        <xsl:value-of select="@text" />
      </span>
      <xsl:text>&#160;</xsl:text>
      <xsl:if test="string-length(@path)>0">
        <span class="css_path">
          <xsl:value-of select="@path" />
        </span>
        <xsl:text>&#160;</xsl:text>
      </xsl:if>
      <xsl:if test="$varChildCount!=0">
        <span>
          <xsl:text>[</xsl:text>
          <xsl:value-of select="$varChildCount" />
          <xsl:text>]</xsl:text>
        </span>
        <xsl:apply-templates select="msxsl:node-set($varChildNodes)/*">
          <xsl:sort select="@text"/>
          <xsl:sort select="@path"/>
        </xsl:apply-templates>
      </xsl:if>
    </div>
  </xsl:template>

</xsl:stylesheet> 