*////////////// Save as treesol_html.prg
#DEFINE C_DBFFILE		HOME(2) + "solution\solution.dbf"
#DEFINE C_XSLFILE		"sol_trans.xslt"
#DEFINE C_XMLFILE		"tree_refs.xml"
#DEFINE C_OUTFILE		"tree.htm"
#DEFINE C_ROOT_NM		"prmRootParent"
#DEFINE C_ROOT_ID		"0_"
#DEFINE SW_NORMAL		1
#DEFINE CRLF			CHR(13) + CHR(10)

SET DEFAULT TO (LEFT(SYS(16), RAT("\", SYS(16)))) 
*///////////////////////////////////////////
*// Step0: Convert DBF to XML
*//
*
*-- Open dbf-tree-file
LOCAL lcTreeFile as String
lcTreeFile = C_DBFFILE
IF !FILE(lcTreeFile)
	RETURN .F.
ENDIF	
LOCAL lcAlias as String
lcAlias = PROPER(JUSTSTEM(lcTreeFile))
IF !USED(lcAlias)
	USE (lcTreeFile) IN 0 SHARED  
	IF !USED(lcAlias)
		RETURN .F.
	ENDIF
ENDIF
LOCAL lcXmlData as String 	
lnLength = CURSORTOXML(lcAlias, 'lcXmlData', 3, 16+8)
USE IN (lcAlias)
*
*-- Save as xml-file
IF FILE(C_XMLFILE)
	ERASE (C_XMLFILE)
ENDIF	
STRTOFILE(lcXmlData, C_XMLFILE)

*
*-- MSXML PROGIDs
LOCAL lcMsxmlVersion As String ;
	,lcPROGIDmsxml As String ;
	,lcPROGIDmsxsl As String ;
	,lcPROGIDmstemp As String
*lcMsxmlVersion = "3.0"
lcMsxmlVersion = "4.0"
lcPROGIDmsxml = "Msxml2.DOMDocument." + lcMsxmlVersion
lcPROGIDmsxsl = "Msxml2.FreeThreadedDOMDocument." + lcMsxmlVersion
lcPROGIDmstemp = "Msxml2.XSLTemplate." + lcMsxmlVersion

*
*-- Create MSXML objects
LOCAL loMsXml As msxml2.DOMDocument ;
	,loMsXsl As msxml2.FreeThreadedDOMDocument ;
	,loMsPrc As msxml2.XSLTemplate ;
	,lobjXSLTProc As msxml2.IXSLProcessor
loMsXml = CREATEOBJECT(lcPROGIDmsxml)
IF VARTYPE(loMsXml) # 'O'
	RETURN .F.
ENDIF
loMsXsl = CREATEOBJECT(lcPROGIDmsxsl)
loMsPrc = CREATEOBJECT(lcPROGIDmstemp)

*///////////////////////////////////////////
*// Step1: Transform (XML + XSLT) -> HTML
*//
LOCAL lnLen as Number;
	,cOut as String
lcOut = ""
lnLen = 0
IF FILE(C_XMLFILE)
	loMsXml.async = .F.
	loMsXml.load(C_XMLFILE)			&& Load XML-file
	IF loMsXml.parseError.errorCode <> 0
		ShowXmlErr(loMsXml.parseError)
		RETURN .F.
	ENDIF 
	loMsXsl.async = .F.
	loMsXsl.load(C_XSLFILE)			&& Load XSL-file
	IF loMsXsl.parseError.errorCode <> 0
		ShowXmlErr(loMsXsl.parseError)
		RETURN .F.
	ENDIF 
	loMsPrc.stylesheet = loMsXsl.documentElement
	lobjXSLTProc = loMsPrc.createProcessor()
	IF VARTYPE(lobjXSLTProc) = "O"
		lobjXSLTProc.input = loMsXml
		IF !EMPTY(C_ROOT_NM)
			lobjXSLTProc.addParameter(C_ROOT_NM, C_ROOT_ID, "")
		ENDIF	
		*
		*-- Transform (XML + XSLT) -> HTML
		IF lobjXSLTProc.transform()
			lcOut = lobjXSLTProc.output
			lnLen = LENC(lcOut)
		ENDIF
	ENDIF
ELSE
	RETURN .F.
ENDIF

STORE NULL TO ;
	loMsXml, loMsXsl, loMsPrc, lobjXSLTProc

*/////////////////////////////////
*// Step2: show result
*//
IF lnLen > 0
	*
	*-- Save result
	IF FILE(C_OUTFILE)
		ERASE (C_OUTFILE)
	ENDIF	
	IF STRTOFILE(lcOut, C_OUTFILE) > 0
		lcOut = ""
		*
		*-- Show result
		LOCAL lnCode As Number
		DECLARE LONG ShellExecute IN shell32.dll ;
			LONG hwnd;
			,STRING lpOperation;
			,STRING lpFile;
			,STRING lpParameters;
			,STRING lpDirectory;
			,LONG nShowCmd
		lnCode = ShellExecute(0, "open", C_OUTFILE, NULL, NULL, SW_NORMAL)
	ENDIF
ENDIF
CLEAR DLLS
CLEAR ALL

*////////////////////////////////
*// ShowXmlErr
FUNCTION ShowXmlErr
LPARAMETERS toXmlErr as Msxml2.IXMLDOMParseError
	IF VARTYPE(toXmlErr) # 'O'
		RETURN .F.
	ENDIF	 
	WITH toXmlErr  
		lcMsg = "Error loading '" + ALLTRIM(.url) + "'" 
		lcMsg = lcMsg + CRLF + "Code: " + TRANSFORM(.errorCode, '@0')
		IF !EMPTY(.reason)
			lcMsg = lcMsg + CRLF + "Reason: " + ALLTRIM(.reason)
		ENDIF	
		IF !EMPTY(.filepos)
			lcMsg = lcMsg + CRLF + "Filepos: " + TRANSFORM(.filepos)
		ENDIF
		IF !EMPTY(.linepos)
			lcMsg = lcMsg + CRLF + "Linepos: " + TRANSFORM(.linepos)
		ENDIF
		IF !EMPTY(.line)
			lcMsg = lcMsg + CRLF + "Line: " + TRANSFORM(.line)
		ENDIF
		IF !EMPTY(.srcText)
			lcMsg = lcMsg + CRLF + "Text: " + ALLTRIM(.srcText)
		ENDIF
		MESSAGEBOX(lcMsg, 16, _SCREEN.Caption)	
	ENDWITH	
ENDFUNC
*////////////// The end of treesol_html.prg